commit 525b0d3fcdfe93004014cdb978f703ae84e71d5b
Author: Ingo Weinhold <ingo_weinhold@gmx.de>
Date:   Fri Feb 10 19:40:27 2012 +0100

    Stash work in progress

diff --git a/build/jam/BuildSetup b/build/jam/BuildSetup
index 41e72a2..63bfea2 100644
--- a/build/jam/BuildSetup
+++ b/build/jam/BuildSetup
@@ -773,8 +773,8 @@ if $(HOST_PLATFORM_BEOS_COMPATIBLE) {
 	HOST_HAIKU_COMPATIBILITY_LIBS = libhaikucompat.a ;
 } else {
 	HOST_LIBSTDC++ = stdc++ ;
-	HOST_LIBROOT = libroot_build_function_remapper.a libroot_build.so ;
-	HOST_STATIC_LIBROOT = libroot_build_function_remapper.a libroot_build.a ;
+	HOST_LIBROOT = libroot_build.so ;
+	HOST_STATIC_LIBROOT = libroot_build.a ;
 	HOST_LIBBE = libbe_build.so ;
 	if $(HOST_PLATFORM) = cygwin {
 		HOST_ADD_BUILD_COMPATIBILITY_LIB_DIR
@@ -897,7 +897,9 @@ HOST_BE_API_C++FLAGS = ;
 
 if ! $(HOST_PLATFORM_BEOS_COMPATIBLE) {
 	HOST_BE_API_HEADERS =
+		[ FDirName $(HAIKU_BUILD_OUTPUT_DIR) ]
 		[ FDirName $(HAIKU_TOP) headers build ]
+		[ FDirName $(HAIKU_TOP) headers build posix ]
 		[ FDirName $(HAIKU_TOP) headers build os ]
 		[ FDirName $(HAIKU_TOP) headers build os app ]
 		[ FDirName $(HAIKU_TOP) headers build os drivers ]
@@ -908,8 +910,10 @@ if ! $(HOST_PLATFORM_BEOS_COMPATIBLE) {
 		[ FDirName $(HAIKU_TOP) headers build os support ]
 		[ FDirName $(HAIKU_TOP) headers build private ]
 	;
-	HOST_BE_API_CCFLAGS = -include BeOSBuildCompatibility.h ;
+#	HOST_BE_API_CCFLAGS = -include BeOSBuildCompatibility.h ;
+	HOST_BE_API_CCFLAGS += -nostdinc ;
 	HOST_BE_API_C++FLAGS = $(HOST_BE_API_CCFLAGS) ;
+	HOST_BE_API_C++FLAGS += -nostdinc++ ;
 }
 
 # Add directory with system headers we need when building something for the host
diff --git a/headers/build/HaikuBuild.h b/headers/build/HaikuBuild.h
new file mode 100644
index 0000000..044bf7a
--- /dev/null
+++ b/headers/build/HaikuBuild.h
@@ -0,0 +1,28 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_H
+#define _HAIKU_BUILD_H
+
+
+#include <HaikuHostBuildConfig.h>
+
+
+#define _HAIKU_BUILD_STRING(string)
+#define _HAIKU_BUILD_ASMNAME(name) \
+	_HAIKU_BUILD_STRING(__USER_LABEL_PREFIX__) name
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	define _HAIKU_BUILD_DECLARE_FUNCTION(returnValue, name, parameters)	\
+		returnValue _haiku_build_##name parameters;
+#else
+#	define _HAIKU_BUILD_DECLARE_FUNCTION(returnValue, name, parameters)	\
+		returnValue _haiku_build_##name parameters;						\
+		returnValue name parameters										\
+			__asm__(_HAIKU_BUILD_ASMNAME("_haiku_build_" #name));
+#endif
+
+
+#endif	/* _HAIKU_BUILD_H */
diff --git a/headers/build/config_build/HaikuConfig.h b/headers/build/config_build/HaikuConfig.h
index 8d49522..91e5509 100644
--- a/headers/build/config_build/HaikuConfig.h
+++ b/headers/build/config_build/HaikuConfig.h
@@ -1,11 +1,14 @@
 /*
- * Copyright 2009-2010, Haiku, Inc. All Rights Reserved.
+ * Copyright 2009-2011, Haiku, Inc. All Rights Reserved.
  * Distributed under the terms of the MIT License.
  */
 #ifndef _CONFIG_HAIKU_CONFIG_H
 #define _CONFIG_HAIKU_CONFIG_H
 
 
+#include <HaikuBuild.h>
+
+
 /* Determine the architecture and define macros for some fundamental
    properties:
    __HAIKU_ARCH					- short name of the architecture (used in paths)
@@ -18,26 +21,26 @@
    								  (defaults to undefined)
 */
 #ifdef __INTEL__
-#	define __HAIKU_ARCH				x86
-#	define __HAIKU_ARCH_X86			1
+#	define __HAIKU_BUILD_HAIKU_ARCH				x86
+#	define __HAIKU_BUILD_HAIKU_ARCH_X86			1
 #elif __x86_64__
-#	define __HAIKU_ARCH				x86_64
-#	define __HAIKU_ARCH_X86_64		1
-#	define __HAIKU_ARCH_BITS		64
+#	define __HAIKU_BUILD_HAIKU_ARCH				x86_64
+#	define __HAIKU_BUILD_HAIKU_ARCH_X86_64		1
+#	define __HAIKU_BUILD_HAIKU_ARCH_BITS		64
 #elif __POWERPC__
-#	define __HAIKU_ARCH				ppc
-#	define __HAIKU_ARCH_PPC			1
-#	define __HAIKU_BIG_ENDIAN		1
+#	define __HAIKU_BUILD_HAIKU_ARCH				ppc
+#	define __HAIKU_BUILD_HAIKU_ARCH_PPC			1
+#	define __HAIKU_BUILD_HAIKU_BIG_ENDIAN		1
 #elif __M68K__
-#	define __HAIKU_ARCH				m68k
-#	define __HAIKU_ARCH_M68K		1
-#	define __HAIKU_BIG_ENDIAN		1
+#	define __HAIKU_BUILD_HAIKU_ARCH				m68k
+#	define __HAIKU_BUILD_HAIKU_ARCH_M68K		1
+#	define __HAIKU_BUILD_HAIKU_BIG_ENDIAN		1
 #elif __MIPSEL__
-#	define __HAIKU_ARCH				mipsel
-#	define __HAIKU_ARCH_MIPSEL		1
+#	define __HAIKU_BUILD_HAIKU_ARCH				mipsel
+#	define __HAIKU_BUILD_HAIKU_ARCH_MIPSEL		1
 #elif __ARM__
-#	define __HAIKU_ARCH				arm
-#	define __HAIKU_ARCH_ARM			1
+#	define __HAIKU_BUILD_HAIKU_ARCH				arm
+#	define __HAIKU_BUILD_HAIKU_ARCH_ARM			1
 #else
 #	error Unsupported architecture!
 #endif
@@ -53,40 +56,104 @@
 */
 
 /* bitness */
-#ifndef __HAIKU_ARCH_BITS
-#	define __HAIKU_ARCH_BITS		32
+#ifndef __HAIKU_BUILD_HAIKU_ARCH_BITS
+#	define __HAIKU_BUILD_HAIKU_ARCH_BITS		32
 #endif
 
-#if __HAIKU_ARCH_BITS == 32
-#	define __HAIKU_ARCH_32_BIT		1
-#elif __HAIKU_ARCH_BITS == 64
-#	define __HAIKU_ARCH_64_BIT		1
+#if __HAIKU_BUILD_HAIKU_ARCH_BITS == 32
+#	define __HAIKU_BUILD_HAIKU_ARCH_32_BIT		1
+#elif __HAIKU_BUILD_HAIKU_ARCH_BITS == 64
+#	define __HAIKU_BUILD_HAIKU_ARCH_64_BIT		1
 #else
 #	error Unsupported bitness!
 #endif
 
 /* physical bitness */
-#ifndef __HAIKU_ARCH_PHYSICAL_BITS
-#	define __HAIKU_ARCH_PHYSICAL_BITS	__HAIKU_ARCH_BITS
+#ifndef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS
+#	define __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS	\
+		__HAIKU_BUILD_HAIKU_ARCH_BITS
 #endif
 
-#if __HAIKU_ARCH_PHYSICAL_BITS == 32
-#	define __HAIKU_ARCH_PHYSICAL_32_BIT	1
-#elif __HAIKU_ARCH_PHYSICAL_BITS == 64
-#	define __HAIKU_ARCH_PHYSICAL_64_BIT	1
+#if __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS == 32
+#	define __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_32_BIT	1
+#elif __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS == 64
+#	define __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT	1
 #else
 #	error Unsupported physical bitness!
 #endif
 
 /* endianess */
-#ifndef __HAIKU_BIG_ENDIAN
-#	define	__HAIKU_LITTLE_ENDIAN	1
+#ifndef __HAIKU_BUILD_HAIKU_BIG_ENDIAN
+#	define	__HAIKU_BUILD_HAIKU_LITTLE_ENDIAN	1
 #endif
 
 /* architecture specific include macros */
-#define __HAIKU_ARCH_HEADER(header)					<arch/__HAIKU_ARCH/header>
+#define __HAIKU_BUILD_HAIKU_ARCH_HEADER(header)		<arch/__HAIKU_ARCH/header>
+#define __HAIKU_BUILD_HAIKU_SUBDIR_ARCH_HEADER(subdir, header)	\
+	<subdir/arch/__HAIKU_BUILD_HAIKU_ARCH/header>
+
+
+/* map the macros, if not building the libroot mapper functions */
+
+#ifndef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+
+#define __HAIKU_ARCH				__HAIKU_BUILD_HAIKU_ARCH
+#define __HAIKU_ARCH_BITS			__HAIKU_BUILD_HAIKU_ARCH_BITS
+#define __HAIKU_ARCH_PHYSICAL_BITS	__HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_X86
+#	define __HAIKU_ARCH_X86	__HAIKU_BUILD_HAIKU_ARCH_X86
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_X86_64
+#	define __HAIKU_ARCH_X86_64	__HAIKU_BUILD_HAIKU_ARCH_X86_64
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PPC
+#	define __HAIKU_ARCH_PPC	__HAIKU_BUILD_HAIKU_ARCH_PPC
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_M68K
+#	define __HAIKU_ARCH_M68K	__HAIKU_BUILD_HAIKU_ARCH_M68K
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_MIPSEL
+#	define __HAIKU_ARCH_MIPSEL	__HAIKU_BUILD_HAIKU_ARCH_MIPSEL
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_ARM
+#	define __HAIKU_ARCH_ARM	__HAIKU_BUILD_HAIKU_ARCH_ARM
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_32_BIT
+#	define __HAIKU_ARCH_32_BIT	__HAIKU_BUILD_HAIKU_ARCH_32_BIT
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_64_BIT
+#	define __HAIKU_ARCH_64_BIT	__HAIKU_BUILD_HAIKU_ARCH_64_BIT
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_32_BIT
+#	define __HAIKU_ARCH_PHYSICAL_32_BIT	__HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_32_BIT
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT
+#	define __HAIKU_ARCH_PHYSICAL_64_BIT	__HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_LITTLE_ENDIAN
+#	define __HAIKU_ARCH_LITTLE_ENDIAN	__HAIKU_BUILD_HAIKU_ARCH_LITTLE_ENDIAN
+#endif
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_BIG_ENDIAN
+#	define __HAIKU_ARCH_BIG_ENDIAN	__HAIKU_BUILD_HAIKU_ARCH_BIG_ENDIAN
+#endif
+
+
+#define __HAIKU_ARCH_HEADER(header)	__HAIKU_BUILD_HAIKU_ARCH_HEADER(header)
 #define __HAIKU_SUBDIR_ARCH_HEADER(subdir, header)	\
-	<subdir/arch/__HAIKU_ARCH/header>
+	__HAIKU_BUILD_HAIKU_SUBDIR_ARCH_HEADER(subdir, header)
 
+#endif	/* _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER */
 
 #endif	/* _CONFIG_HAIKU_CONFIG_H */
diff --git a/headers/build/config_build/types.h b/headers/build/config_build/types.h
index 960e1ce..53da55d 100644
--- a/headers/build/config_build/types.h
+++ b/headers/build/config_build/types.h
@@ -6,9 +6,9 @@
 #define _CONFIG_BUILD_TYPES_H
 
 
-#include <config_build/HaikuConfig.h>
+#include <HaikuBuild.h>
 
-#include <inttypes.h>
+#include <config_build/HaikuConfig.h>
 
 
 /* fixed-width types -- the __haiku_std_[u]int* types correspond to the POSIX
@@ -16,97 +16,154 @@
    __HAIKU_BEOS_COMPATIBLE_TYPES is not defined both sets are identical. Once
    we drop compatibility for good, we can consolidate the types.
 */
-typedef int8_t				__haiku_std_int8;
-typedef uint8_t				__haiku_std_uint8;
-typedef int16_t				__haiku_std_int16;
-typedef uint16_t			__haiku_std_uint16;
-typedef int32_t				__haiku_std_int32;
-typedef uint32_t			__haiku_std_uint32;
-typedef int64_t				__haiku_std_int64;
-typedef uint64_t			__haiku_std_uint64;
-
-typedef __haiku_std_int8	__haiku_int8;
-typedef __haiku_std_uint8	__haiku_uint8;
-typedef __haiku_std_int16	__haiku_int16;
-typedef __haiku_std_uint16	__haiku_uint16;
-typedef __haiku_std_int32	__haiku_int32;
-typedef __haiku_std_uint32	__haiku_uint32;
-typedef __haiku_std_int64	__haiku_int64;
-typedef __haiku_std_uint64	__haiku_uint64;
+typedef _HAIKU_BUILD_FEATURE_int8	__haiku_build_haiku_std_int8;
+typedef _HAIKU_BUILD_FEATURE_uint8	__haiku_build_haiku_std_uint8;
+typedef _HAIKU_BUILD_FEATURE_int16	__haiku_build_haiku_std_int16;
+typedef _HAIKU_BUILD_FEATURE_uint16	__haiku_build_haiku_std_uint16;
+typedef _HAIKU_BUILD_FEATURE_int32	__haiku_build_haiku_std_int32;
+typedef _HAIKU_BUILD_FEATURE_uint32	__haiku_build_haiku_std_uint32;
+typedef _HAIKU_BUILD_FEATURE_int64	__haiku_build_haiku_std_int64;
+typedef _HAIKU_BUILD_FEATURE_uint64	__haiku_build_haiku_std_uint64;
+
+typedef __haiku_build_haiku_std_int8	__haiku_build_haiku_int8;
+typedef __haiku_build_haiku_std_uint8	__haiku_build_haiku_uint8;
+typedef __haiku_build_haiku_std_int16	__haiku_build_haiku_int16;
+typedef __haiku_build_haiku_std_uint16	__haiku_build_haiku_uint16;
+typedef __haiku_build_haiku_std_int32	__haiku_build_haiku_int32;
+typedef __haiku_build_haiku_std_uint32	__haiku_build_haiku_uint32;
+typedef __haiku_build_haiku_std_int64	__haiku_build_haiku_int64;
+typedef __haiku_build_haiku_std_uint64	__haiku_build_haiku_uint64;
 
 /* address types */
-#ifdef __HAIKU_ARCH_64_BIT
-	typedef	__haiku_int64	__haiku_saddr_t;
-	typedef	__haiku_uint64	__haiku_addr_t;
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_64_BIT
+	typedef	__haiku_build_haiku_int64	__haiku_build_haiku_saddr_t;
+	typedef	__haiku_build_haiku_uint64	__haiku_build_haiku_addr_t;
 #else
-	typedef	__haiku_int32	__haiku_saddr_t;
-	typedef	__haiku_uint32	__haiku_addr_t;
+	typedef	__haiku_build_haiku_int32	__haiku_build_haiku_saddr_t;
+	typedef	__haiku_build_haiku_uint32	__haiku_build_haiku_addr_t;
 #endif
 
-#ifdef __HAIKU_ARCH_PHYSICAL_64_BIT
-	typedef	__haiku_int64	__haiku_phys_saddr_t;
-	typedef	__haiku_uint64	__haiku_phys_addr_t;
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT
+	typedef	__haiku_build_haiku_int64	__haiku_build_haiku_phys_saddr_t;
+	typedef	__haiku_build_haiku_uint64	__haiku_build_haiku_phys_addr_t;
 #else
-	typedef	__haiku_int32	__haiku_phys_saddr_t;
-	typedef	__haiku_uint32	__haiku_phys_addr_t;
+	typedef	__haiku_build_haiku_int32	__haiku_build_haiku_phys_saddr_t;
+	typedef	__haiku_build_haiku_uint32	__haiku_build_haiku_phys_addr_t;
 #endif
 
 /* address type limits */
-#ifdef __HAIKU_ARCH_64_BIT
-#	define __HAIKU_SADDR_MAX		(9223372036854775807LL)
-#	define __HAIKU_ADDR_MAX			(18446744073709551615ULL)
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_64_BIT
+#	define __HAIKU_BUILD_HAIKU_SADDR_MAX		(9223372036854775807LL)
+#	define __HAIKU_BUILD_HAIKU_ADDR_MAX			(18446744073709551615ULL)
 #else
-#	define __HAIKU_SADDR_MAX		(2147483647)
-#	define __HAIKU_ADDR_MAX			(4294967295U)
+#	define __HAIKU_BUILD_HAIKU_SADDR_MAX		(2147483647)
+#	define __HAIKU_BUILD_HAIKU_ADDR_MAX			(4294967295U)
 #endif
-#define __HAIKU_SADDR_MIN			(-__HAIKU_SADDR_MAX-1)
+#define __HAIKU_BUILD_HAIKU_SADDR_MIN		(-__HAIKU_BUILD_HAIKU_SADDR_MAX-1)
 
-#ifdef __HAIKU_ARCH_PHYSICAL_64_BIT
-#	define __HAIKU_PHYS_SADDR_MAX	(9223372036854775807LL)
-#	define __HAIKU_PHYS_ADDR_MAX	(18446744073709551615ULL)
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT
+#	define __HAIKU_BUILD_HAIKU_PHYS_SADDR_MAX	(9223372036854775807LL)
+#	define __HAIKU_BUILD_HAIKU_PHYS_ADDR_MAX	(18446744073709551615ULL)
 #else
-#	define __HAIKU_PHYS_SADDR_MAX	(2147483647)
-#	define __HAIKU_PHYS_ADDR_MAX	(4294967295U)
+#	define __HAIKU_BUILD_HAIKU_PHYS_SADDR_MAX	(2147483647)
+#	define __HAIKU_BUILD_HAIKU_PHYS_ADDR_MAX	(4294967295U)
 #endif
-#define __HAIKU_PHYS_SADDR_MIN		(-__HAIKU_SADDR_MAX-1)
+#define __HAIKU_BUILD_HAIKU_PHYS_SADDR_MIN	(-__HAIKU_BUILD_HAIKU_SADDR_MAX-1)
 
 
 /* printf()/scanf() format prefixes */
-/* TODO: The following are only guesses! We should define them in the
-   build/host headers. */
-#define	__HAIKU_STD_PRI_PREFIX_32	""
-#ifdef __HAIKU_ARCH_64_BIT
-#	define __HAIKU_STD_PRI_PREFIX_64	"l"
+#define	__HAIKU_BUILD_HAIKU_STD_PRI_PREFIX_32	\
+	_HAIKU_BUILD_FEATURE_FORMAT_PREFIX_int32
+#define __HAIKU_BUILD_HAIKU_STD_PRI_PREFIX_64	\
+	_HAIKU_BUILD_FEATURE_FORMAT_PREFIX_int64
+
+#define	__HAIKU_BUILD_HAIKU_PRI_PREFIX_32	\
+	__HAIKU_BUILD_HAIKU_STD_PRI_PREFIX_32
+#define	__HAIKU_BUILD_HAIKU_PRI_PREFIX_64	\
+	__HAIKU_BUILD_HAIKU_STD_PRI_PREFIX_64
+
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_64_BIT
+#	define __HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR	\
+		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64
 #else
-#	define __HAIKU_STD_PRI_PREFIX_64	"ll"
+#	define __HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR	\
+		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32
 #endif
 
-#define	__HAIKU_PRI_PREFIX_32		__HAIKU_STD_PRI_PREFIX_32
-#define	__HAIKU_PRI_PREFIX_64		__HAIKU_STD_PRI_PREFIX_64
-
-#ifdef __HAIKU_ARCH_64_BIT
-#	define __HAIKU_PRI_PREFIX_ADDR	__HAIKU_PRI_PREFIX_64
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT
+#	define __HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR	\
+		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64
 #else
-#	define __HAIKU_PRI_PREFIX_ADDR	__HAIKU_PRI_PREFIX_32
-#endif
-
-#ifdef __HAIKU_ARCH_PHYSICAL_64_BIT
-#	define __HAIKU_PRI_PREFIX_PHYS_ADDR	__HAIKU_PRI_PREFIX_64
-#else
-#	define __HAIKU_PRI_PREFIX_PHYS_ADDR	__HAIKU_PRI_PREFIX_32
+#	define __HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR	\
+		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32
 #endif
 
 
 /* a generic address type wide enough for virtual and physical addresses */
-#if __HAIKU_ARCH_BITS >= __HAIKU_ARCH_PHYSICAL_BITS
-	typedef __haiku_addr_t					__haiku_generic_addr_t;
-#	define __HAIKU_GENERIC_ADDR_MAX			__HAIKU_ADDR_MAX
-#	define __HAIKU_PRI_PREFIX_GENERIC_ADDR	__HAIKU_PRI_PREFIX_ADDR
+#if __HAIKU_BUILD_HAIKU_ARCH_BITS >= __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS
+	typedef __haiku_build_haiku_addr_t		__haiku_build_haiku_generic_addr_t;
+#	define __HAIKU_BUILD_HAIKU_GENERIC_ADDR_MAX			\
+		__HAIKU_BUILD_HAIKU_ADDR_MAX
+#	define __HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR	\
+		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR
 #else
-	typedef __haiku_phys_addr_t				__haiku_generic_addr_t;
-#	define __HAIKU_GENERIC_ADDR_MAX			__HAIKU_PHYS_ADDR_MAX
-#	define __HAIKU_PRI_PREFIX_GENERIC_ADDR	__HAIKU_PRI_PREFIX_PHYS_ADDR
+	typedef __haiku_build_haiku_phys_addr_t	__haiku_build_haiku_generic_addr_t;
+#	define __HAIKU_BUILD_HAIKU_GENERIC_ADDR_MAX			\
+		__HAIKU_BUILD_HAIKU_PHYS_ADDR_MAX
+#	define __HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR	\
+		__HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR
 #endif
 
 
+/* map the macros/types, if not building the libroot mapper functions */
+
+#ifndef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+
+typedef __haiku_build_haiku_std_int8	__haiku_std_int8;
+typedef __haiku_build_haiku_std_uint8	__haiku_std_uint8;
+typedef __haiku_build_haiku_std_int16	__haiku_std_int16;
+typedef __haiku_build_haiku_std_uint16	__haiku_std_uint16;
+typedef __haiku_build_haiku_std_int32	__haiku_std_int32;
+typedef __haiku_build_haiku_std_uint32	__haiku_std_uint32;
+typedef __haiku_build_haiku_std_int64	__haiku_std_int64;
+typedef __haiku_build_haiku_std_uint64	__haiku_std_uint64;
+
+typedef __haiku_build_haiku_int8	__haiku_int8;
+typedef __haiku_build_haiku_uint8	__haiku_uint8;
+typedef __haiku_build_haiku_int16	__haiku_int16;
+typedef __haiku_build_haiku_uint16	__haiku_uint16;
+typedef __haiku_build_haiku_int32	__haiku_int32;
+typedef __haiku_build_haiku_uint32	__haiku_uint32;
+typedef __haiku_build_haiku_int64	__haiku_int64;
+typedef __haiku_build_haiku_uint64	__haiku_uint64;
+
+typedef	__haiku_build_haiku_saddr_t			__haiku_saddr_t;
+typedef	__haiku_build_haiku_addr_t			__haiku_addr_t;
+typedef	__haiku_build_haiku_phys_saddr_t	__haiku_phys_saddr_t;
+typedef	__haiku_build_haiku_phys_addr_t		__haiku_phys_addr_t;
+
+#define __HAIKU_SADDR_MAX	__HAIKU_BUILD_HAIKU_SADDR_MAX
+#define __HAIKU_ADDR_MAX	__HAIKU_BUILD_HAIKU_ADDR_MAX
+#define __HAIKU_SADDR_MIN	__HAIKU_BUILD_HAIKU_SADDR_MIN
+
+#define __HAIKU_PHYS_SADDR_MAX	__HAIKU_BUILD_HAIKU_PHYS_SADDR_MAX
+#define __HAIKU_PHYS_ADDR_MAX	__HAIKU_BUILD_HAIKU_PHYS_ADDR_MAX
+#define __HAIKU_PHYS_SADDR_MIN	__HAIKU_BUILD_HAIKU_PHYS_SADDR_MIN
+
+#define	__HAIKU_STD_PRI_PREFIX_32	__HAIKU_BUILD_HAIKU_STD_PRI_PREFIX_32
+#define __HAIKU_STD_PRI_PREFIX_64	__HAIKU_BUILD_HAIKU_STD_PRI_PREFIX_64
+
+#define	__HAIKU_PRI_PREFIX_32	__HAIKU_BUILD_HAIKU_PRI_PREFIX_32
+#define	__HAIKU_PRI_PREFIX_64	__HAIKU_BUILD_HAIKU_PRI_PREFIX_64
+
+#define __HAIKU_PRI_PREFIX_ADDR			__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR
+#define __HAIKU_PRI_PREFIX_PHYS_ADDR	__HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR
+
+typedef __haiku_build_haiku_generic_addr_t		__haiku_generic_addr_t;
+#define __HAIKU_GENERIC_ADDR_MAX	__HAIKU_BUILD_HAIKU_GENERIC_ADDR_MAX
+#define __HAIKU_PRI_PREFIX_GENERIC_ADDR		\
+	__HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR
+
+#endif	/* _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER */
+
 #endif	/* _CONFIG_BUILD_TYPES_H */
diff --git a/headers/build/os/BeBuild.h b/headers/build/os/BeBuild.h
index 3130e03..6c34e0d 100644
--- a/headers/build/os/BeBuild.h
+++ b/headers/build/os/BeBuild.h
@@ -2,81 +2,86 @@
  * Copyright 2007-2010, Haiku, Inc. All Rights Reserved.
  * Distributed under the terms of the MIT License.
  */
-#ifndef _BE_BUILD_H
-#define _BE_BUILD_H
+#ifndef _HAIKU_BUILD_BE_BUILD_H
+#define _HAIKU_BUILD_BE_BUILD_H
 
 
 #include <config_build/HaikuConfig.h>
 
 
-#define B_BEOS_VERSION_4				0x0400
-#define B_BEOS_VERSION_4_5				0x0450
-#define B_BEOS_VERSION_5				0x0500
+#define HAIKU_BUILD_B_BEOS_VERSION_4				0x0400
+#define HAIKU_BUILD_B_BEOS_VERSION_4_5				0x0450
+#define HAIKU_BUILD_B_BEOS_VERSION_5				0x0500
 
-#define B_BEOS_VERSION					B_BEOS_VERSION_5
-#define B_BEOS_VERSION_MAUI				B_BEOS_VERSION_5
+#define HAIKU_BUILD_B_BEOS_VERSION					HAIKU_BUILD_B_BEOS_VERSION_5
+#define HAIKU_BUILD_B_BEOS_VERSION_MAUI				HAIKU_BUILD_B_BEOS_VERSION_5
 
 /* Haiku (API) version */
-#define B_HAIKU_VERSION_BEOS			0x00000001
-#define B_HAIKU_VERSION_BONE			0x00000002
-#define B_HAIKU_VERSION_DANO			0x00000003
-#define B_HAIKU_VERSION_1_ALPHA_1		0x00000100
-#define B_HAIKU_VERSION_1_PRE_ALPHA_2	0x00000101
-#define B_HAIKU_VERSION_1				0x00010000
+#define HAIKU_BUILD_B_HAIKU_VERSION_BEOS			0x00000001
+#define HAIKU_BUILD_B_HAIKU_VERSION_BONE			0x00000002
+#define HAIKU_BUILD_B_HAIKU_VERSION_DANO			0x00000003
+#define HAIKU_BUILD_B_HAIKU_VERSION_1_ALPHA_1		0x00000100
+#define HAIKU_BUILD_B_HAIKU_VERSION_1_PRE_ALPHA_2	0x00000101
+#define HAIKU_BUILD_B_HAIKU_VERSION_1				0x00010000
 
-#define B_HAIKU_VERSION					B_HAIKU_VERSION_1_PRE_ALPHA_2
+#define HAIKU_BUILD_B_HAIKU_VERSION					\
+	HAIKU_BUILD_B_HAIKU_VERSION_1_PRE_ALPHA_2
 
 /* Haiku ABI */
-#define B_HAIKU_ABI_MAJOR				0xffff0000
-#define B_HAIKU_ABI_GCC_2				0x00020000
-#define B_HAIKU_ABI_GCC_4				0x00040000
+#define HAIKU_BUILD_B_HAIKU_ABI_MAJOR				0xffff0000
+#define HAIKU_BUILD_B_HAIKU_ABI_GCC_2				0x00020000
+#define HAIKU_BUILD_B_HAIKU_ABI_GCC_4				0x00040000
 
-#define B_HAIKU_ABI_GCC_2_ANCIENT		0x00020000
-#define B_HAIKU_ABI_GCC_2_BEOS			0x00020001
-#define B_HAIKU_ABI_GCC_2_HAIKU			0x00020002
+#define HAIKU_BUILD_B_HAIKU_ABI_GCC_2_ANCIENT		0x00020000
+#define HAIKU_BUILD_B_HAIKU_ABI_GCC_2_BEOS			0x00020001
+#define HAIKU_BUILD_B_HAIKU_ABI_GCC_2_HAIKU			0x00020002
 
 #if __GNUC__ == 2
-#	define B_HAIKU_ABI					B_HAIKU_ABI_GCC_2_HAIKU
+#	define HAIKU_BUILD_B_HAIKU_ABI					\
+		HAIKU_BUILD_B_HAIKU_ABI_GCC_2_HAIKU
 #elif __GNUC__ == 3 || __GNUC__ == 4
-#	define B_HAIKU_ABI					B_HAIKU_ABI_GCC_4
+#	define HAIKU_BUILD_B_HAIKU_ABI					\
+		HAIKU_BUILD_B_HAIKU_ABI_GCC_4
 #else
 #	error Unsupported gcc version!
 #endif
 
 
-#define B_HAIKU_BITS					__HAIKU_ARCH_BITS
-#define B_HAIKU_PHYSICAL_BITS			__HAIKU_ARCH_PHYSICAL_BITS
+#define HAIKU_BUILD_B_HAIKU_BITS					\
+	__HAIKU_BUILD_HAIKU_ARCH_BITS
+#define HAIKU_BUILD_B_HAIKU_PHYSICAL_BITS			\
+	__HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_BITS
 
-#ifdef __HAIKU_ARCH_64_BIT
-#	define B_HAIKU_64_BIT				1
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_64_BIT
+#	define HAIKU_BUILD_B_HAIKU_64_BIT				1
 #else
-#	define B_HAIKU_32_BIT				1
+#	define HAIKU_BUILD_B_HAIKU_32_BIT				1
 #endif
 
-#ifdef __HAIKU_ARCH_PHYSICAL_64_BIT
-#	define B_HAIKU_PHYSICAL_64_BIT		1
+#ifdef __HAIKU_BUILD_HAIKU_ARCH_PHYSICAL_64_BIT
+#	define HAIKU_BUILD_B_HAIKU_PHYSICAL_64_BIT		1
 #else
-#	define B_HAIKU_PHYSICAL_32_BIT		1
+#	define HAIKU_BUILD_B_HAIKU_PHYSICAL_32_BIT		1
 #endif
 
-#ifdef __HAIKU_BEOS_COMPATIBLE
-#	define B_HAIKU_BEOS_COMPATIBLE		1
+#ifdef __HAIKU_BUILD_HAIKU_BEOS_COMPATIBLE
+#	define HAIKU_BUILD_B_HAIKU_BEOS_COMPATIBLE		1
 #endif
 
 
-#define _UNUSED(argument) argument
-#define _PACKED __attribute__((packed))
-#define _PRINTFLIKE(_format_, _args_) \
+#define _HAIKU_BUILD_UNUSED(argument) argument
+#define _HAIKU_BUILD_PACKED __attribute__((packed))
+#define _HAIKU_BUILD_PRINTFLIKE(_format_, _args_) \
 	__attribute__((format(__printf__, _format_, _args_)))
-#define _EXPORT
-#define _IMPORT
+#define _HAIKU_BUILD_EXPORT
+#define _HAIKU_BUILD_IMPORT
 
 #define B_DEFINE_SYMBOL_VERSION(function, versionedSymbol)	\
 	__asm__(".symver " function "," versionedSymbol)
 
 
-#define _IMPEXP_ROOT
-#define _IMPEXP_BE
+#define _HAIKU_BUILD_IMPEXP_ROOT
+#define _HAIKU_BUILD_IMPEXP_BE
 
 
-#endif	/* _BE_BUILD_H */
+#endif	/* _HAIKU_BUILD_BE_BUILD_H */
